import { system, world, EquipmentSlot } from "@minecraft/server";

world.afterEvents.entityHurt.subscribe(data => {
    const damage = data.damage;
    const player = data.hurtEntity;
    const offhand = player.getComponent("equipment_inventory").getEquipment(EquipmentSlot.offhand);
    const mainhand = player.getComponent("equipment_inventory").getEquipment(EquipmentSlot.mainhand);
    const health = player.getComponent("health")

    // mainhand
    if (player?.getComponent("equipment_inventory")?.getEquipment(EquipmentSlot.mainhand)?.typeId == "totem:totem_absorption" && player?.getComponent("equipment_inventory")?.getEquipment(EquipmentSlot.offhand)?.typeId != "totem:totem_absorption") {
        if (mainhand.getComponent("durability").damage < 64) {
            health.setCurrentValue(health.currentValue + damage)
            player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 totem:totem_absorption 1 ${Math.floor(mainhand.getComponent("durability").damage + damage)}`)
            player.runCommandAsync("playsound totem_absorption @a ~~1~")
        }
        if (mainhand.getComponent("durability").damage >= 64) {
            health.setCurrentValue(health.currentValue + damage)
            player.runCommandAsync("playsound random.break @s ~ ~1 ~")
            player.runCommandAsync("replaceitem entity @s slot.weapon.mainhand 0 air")
            // totem effect
            player.runCommandAsync("playsound random.totem @s ~ ~1 ~")
            player.runCommandAsync("particle minecraft:totem_particle ~ ~1 ~")
            player.addEffect("absorption", 20*5, {amplifier:2})
            player.addEffect("regeneration", 20*40, {amplifier:2})
            player.addEffect("fire_resistance", 20*40)
        }
    }
    // offhand
    if (player?.getComponent("equipment_inventory")?.getEquipment(EquipmentSlot.offhand)?.typeId == "totem:totem_absorption") {
        if (offhand.getComponent("durability").damage < 64) {
            health.setCurrentValue(health.currentValue + damage)
            player.runCommandAsync(`replaceitem entity @s slot.weapon.offhand 0 totem:totem_absorption 1 ${Math.floor(offhand.getComponent("durability").damage + damage)}`)
            player.runCommandAsync("playsound totem_absorption @a ~~1~")
        }
        if (offhand.getComponent("durability").damage >= 64) {
            health.setCurrentValue(health.currentValue + damage)
            player.runCommandAsync("playsound random.break @s ~ ~1 ~")
            player.runCommandAsync("replaceitem entity @s slot.weapon.offhand 0 air")
            // totem effect
            player.runCommandAsync("playsound random.totem @s ~ ~1 ~")
            player.runCommandAsync("particle minecraft:totem_particle ~ ~1 ~")
            player.addEffect("absorption", 20*5, {amplifier:2})
            player.addEffect("regeneration", 20*40, {amplifier:2})
            player.addEffect("fire_resistance", 20*40)
        }
    }
})